CREATE OR REPLACE TRIGGER USR_BLOQ_EXCLUIR_SOLICITA
BEFORE INSERT OR UPDATE OR DELETE
ON ITEMSOLI FOR  EACH ROW

DECLARE
  PRAGMA AUTONOMOUS_TRANSACTION;
  V_DESC        VARCHAR2(500);
  V_DSIP        VARCHAR2(50);
  V_DSUSUARIO   VARCHAR2(50);
  V_DSRDM       VARCHAR2(50);
  V_DSMETODO    VARCHAR2(250);
  V_DSOPERADOR  VARCHAR2(12);
  V_IDSOLIAPROV VARCHAR2(12);
BEGIN
   V_DESC := '';

   WEBTUNNING(V_DSIP,
              V_DSUSUARIO,
              V_DSRDM,
              V_DSMETODO,
              V_DSOPERADOR);

   IF DELETING THEN
      /*
      rdmLancaSoliCmp  = SUP03900 - Lanamento de solicitao de compras
      rdmAltSoliCmp    = CMP07300 - Alterao de solicitao de compras
      rdmAltAutSoliCmp = CMP06900 - Alterao automtica de produtos na solicitao de compras
      */
      IF (SUBSTR(V_DSRDM, 1, 15) = 'rdmLancaSoliCmp') OR (SUBSTR(V_DSRDM, 1, 13) = 'rdmAltSoliCmp') OR (SUBSTR(V_DSRDM, 1, 16) = 'rdmAltAutSoliCmp') THEN
         BEGIN
            SELECT IDSOLIAPROV
              INTO V_IDSOLIAPROV
              FROM ITEMSOLI
             WHERE IDSOLIAPROV = 'S'
               AND NRSOLICMP   = :OLD.NRSOLICMP
               AND CDFILSOLI   = :OLD.CDFILSOLI
               AND CDFILLAN    = :OLD.CDFILLAN;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN BEGIN
               V_IDSOLIAPROV := NULL;
            END;
         END;

         IF V_IDSOLIAPROV = 'S' THEN
            V_DESC := 'Operao bloqueada! No  permitido excluir item ou solicitao de compras quando se tem algum item aprovado.';
            raise_application_error(-20501, V_DESC, True);
         END IF;
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('USR_BLOQ_QUANT_ITEMSOLI','6.10.XXX'); END;
/